ConfigurationSpi (Java Platform SE 8 )
Keywords: javax.security.auth.login.ConfigurationSpi class
Date: 2026-04-17

compact1, compact2, compact3
javax.security.auth.login

## Class ConfigurationSpi

- java.lang.Object
- - javax.security.auth.login.ConfigurationSpi

-     public abstract class ConfigurationSpi
      extends Object

  This class defines the Service Provider Interface (SPI) for the `Configuration` class. All the abstract methods in this class must be implemented by each service provider who wishes to supply a Configuration implementation.

  Subclass implementations of this abstract class must provide a public constructor that takes a `Configuration.Parameters` object as an input parameter. This constructor also must throw an IllegalArgumentException if it does not understand the `Configuration.Parameters` input.

  Since:
    1.6

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConfigurationSpi()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract AppConfigurationEntry[]` | `engineGetAppConfigurationEntry(String name)` Retrieve the AppConfigurationEntries for the specified name.
    `protected void` | `engineRefresh()` Refresh and reload the Configuration.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ConfigurationSpi

          public ConfigurationSpi()

  - ### Method Detail

    - #### engineGetAppConfigurationEntry

          protected abstract AppConfigurationEntry[] engineGetAppConfigurationEntry(String name)

      Retrieve the AppConfigurationEntries for the specified name.

      Parameters:
        `name` - the name used to index the Configuration.
      Returns:
        an array of AppConfigurationEntries for the specified name, or null if there are no entries.

    - #### engineRefresh

          protected void engineRefresh()

      Refresh and reload the Configuration.

      This method causes this Configuration object to refresh/reload its contents in an implementation-dependent manner. For example, if this Configuration object stores its entries in a file, calling `refresh` may cause the file to be re-read.

      The default implementation of this method does nothing. This method should be overridden if a refresh operation is supported by the implementation.

      Throws:
        `SecurityException` - if the caller does not have permission to refresh its Configuration.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.